SCM

(Kommt so in den Folien von WS nicht ganz vor, man kann aber viele Parallen zum VCS (Version Control System) ziehen, bezüglich zentral, verteilt, etc.)
---
SCM = Sourcecode Management System

Aufgaben
 + {{Parallele Projektentwicklung auf mehreren Zweigen}}
 + {{Transparente Änderungen}}
 + {{Nachvollziehbare Entwicklungsgeschichte}}
 + {{Zugriff auf ältere Versionen}}

Zentrales SCM
---
Bei zentralen SCM gibt es einen Server welcher das Repository ist und an den alle SCM-Operationen geschickt werden müssen.
Vorteil: {{Clients benötigen nicht alle Dateien & Versionen und kommen mit weniger Speicherplatz aus}}
Nachteil: {{Server ist Single Point of Failure & Flaschenhals -> einzelne SCM-Operationen können so sehr lange dauern}}

Verteiltes SCM
---
Bei verteilten SCM wird das Repository geklont und auf jedem Client gespeichert. Meist gibt es dabei einen Server mit einem "Main-Repository", mit welchem sich die Clients regelmäßig synchronisieren.
Vorteil: {{Alle SCM-Operationen können lokal ausgeführt werden}}
Nachteil: {{Große Datenmengen werden beim klonen übertragen und auf dem Client gespeichert}}

Arbeitsablauf bei Konflikten
---
Verteiltes SCM
 + {{Kopie des Hauptrepository}}
 + {{Lokale Änderungen}}
 + {{Lokale Commits}}
 + {{Merge: Push /Pull Request}}
 + Beispiel: {{git}}

Zentrales SCM
 + {{Update}}
 + {{Lokale Änderungen}}
 + {{Update: Änderungen remote & lokal / Merge}}
 + {{Commit}}
 + Beispiel: {{ SVN (Subversion), CVS (Concurrent Versions System)}}